import { defineStore } from "pinia";
import { API } from "../Api";
import { Graph, SavedStudy, Variable } from "../components/types";
import { formatDate, formatDateRange, formatNumbers } from "../utilities/utils";


export const useAnalysisGraphStore = defineStore('GraphsStore', {
  state: () => ({
    graphs: [] as Graph[],
    graphData: undefined as undefined | Graph,
  }),
  getters: {
    graph(state) {
      return (index: number) => {
        if (index < state.graphs.length && index >= 0) {
          return state.graphs[index]
        } else {
          console.log("ERROR GRAPH INDEX IS OUT OF RANGE", index)
          return null;
        }
      }
    }
  },
  actions: {
  }
})