This section details all the datasets requirements needed to use this solution.


# Data Sources requirements
In this solution, two data models can be used among 3 options:
- **Option A**: Upload a process events-aggregated file
- **Option B**:  **(Recommended)**  Process parameters and Outcome information datasets
- **Option C**: Process events-aggregated dataset: It's necessary to have data aggregated to the events, not time series data

## Option B: (Recommended)
This solution requires two input datasets : 

 1 .  **[Process parameters dataset](dataset:_process_parameters)**:  Containing instances of parameters on specific events in wide format:
- `event_id` (_string_): Event's unique identifier
- `equipment_id` (_string_): (Optional) Equipment's unique identifier
- `spec_id` (_string_): Parameter set unique identifier
-  `process_parameter_1` ... `process_parameter_n` (_float_): Parameters values
- `date` (_date_): date of the parameter instanciation

   - The schema accepts as many parameter sets and processs parameters as needed.
  
  
   2 .  **[Outcome Information Dataset](dataset:_events_informations)**: Containing events informations:
- `event_id` (_string_): Event's unique identifier
- `equipment_id` (_string_): (Optional) Equipment's unique ID
- `start_date` (_date_): (Optional) Start date of the event
- `end_date` (_date_): (Optional) End date of the event
- `outcome` (_string_ / _date_ / _boolean_ / _float_): Any process outcome measurement to analyze

   - The schema accepts as many outcomes as needed. 

## Option A and C:
The solution can also work with a dataset aggregated to the process events, such as the product. 
In this case, you can either:
- Option A: upload a file such as csv, xls,...
- Option C: connect to an existing table in a database 

Here only one dataset is expected, called the product database.

**[Product Database dataset](dataset:product_database)**

   - This dataset includes aggregated process information at the event level, along with outcome measurements, such as quality measurements. 
   - The schema is quite flexible, facilitating a variety of specific use cases. 
   - However, it has the following mandatory requirements:
     - A product identifier
     - At least one date related to the manufacturing process
     - At least one process measure or parameter

The general schema of the database looks like this:
- `product_identifier`  (_string_): Unique identifier of a product
- `identifier_1` ... `identifier_n`  (_string_): Various identifiers related to the product or process
- `process_parameter_1` ... `process_parameter_n` (_varies_): Several process parameters
- `process_outcome_1` ... `process_outcome_2` (_decimal_, _integer_, _boolean_, etc.): Several process outcomes
- `date_1` ... `date_n`  (_Date_): Several dates related to the manufacturing process

Here, identifiers are unique values that allow us to pinpoint a specific entity, be it a product, a process, a machine, etc. 
   -  _Process parameters _ are values that  **can be adjusted**  during the manufacturing process, and can impact the end quality of the product. 
   -  _Process measures_  are event-aggregated properties recorded from the product or process, for example, weight, length, temperature, etc. 
   -  _Dates _ are timestamps related to the manufacturing process such as the start date of the process, end date, inspection date, etc. 

You can add as many columns as necessary for identifiers, process parameters, process measures, and dates. However, dates are not analyzed as part of this solution.