To use this solution, you  **should not use the project itself**  but the [Dataiku Application](https://doc.dataiku.com/dss/latest/applications/index.html) that comes with it. This application should be available on the  **home page of Dataiku under the Applications section**.

It will help you connect your data regardless of the connection type and configure the whole flow according to your specific parameters seamlessly. 


Create a new Dataiku application by clicking the  **CREATE APP INSTANCE**  button. This will create a new instance of the parent project, which you can configure according to your specific needs. You can create as many instances as you need (for example, if you want to apply this solution to other data).

# STEP 1 : Input data configuration
### Option A: Upload a dataset
![option_A.png](5RUbUgssSsX9)
Drag and drop any [supported file format](https://doc.dataiku.com/dss/latest/connecting/upload.html) respecting the [event-aggregated data model](article:1)
You can review the auto-infered schema by clicking on   _View settings of dataset product_database_upload_  

Regarding dates: if one or more date columns are not automatically recognized by Dataiku, the most common date formats are automatically handled when clicking the "Load & Check" button. The formats automatically supported include:
```
yyyy-MM-DD HH:mm:SS
yyyy-MM-dd'T'HH:mm:ss
DD-MM-yyyy HH:mm:SS
yyyy/MM/DD
DD/MM/yyyy
DD-MM-yyyy
DD-MM-yy
```

### Option B: Connect to an existing database respecting the 2-datasets data model
![option_B.png](1TDiyrcGqCEN)
  1. Select your connections : 
   - select the connection that can connect to the [two input datasets](article:1)
    - click on the  **RECONFIGURE** button
   2. Now that the connections are configured, you need to select the table/file that should be used as inputs within this connection : 
   - click on  **process_parameters** .It will open the dataset configuration window, where you can select the table or file (depending on your connection type) that will be used as process parameters data. Once selected, click on  **SAVE**  in the top right corner, and come back to the application configuration page by clicking on the name of the dataiku application instance.
   - do the same with **events_informations** to connect sensor data.

### Option C - Connect to an existing event-agregated database
![option_C.png](Kb1dutPsaHMF)
It's the same logic as previously but with 1 dataset:
  1. Select your connections : 
   - select the connection that can connect to the [input dataset](article:1)
    - click on the  **RECONFIGURE** button
   2. Now that the connections are configured, you need to select the table/file that should be used as inputs within this connection : 
   - click on  **product_database** .It will open the dataset configuration window, where you can select the table or file (depending on your connection type) that will be used as process parameters data. Once selected, click on  **SAVE**  in the top right corner, and come back to the application configuration page by clicking on the name of the dataiku application instance.

# STEP 2 : Analysis preparation
To have the analysis prepared, we need to define a reference date variable, that you can select from the menu. If you don't see your variables, click on the Refresh! button.

Also, you can add filters here, by clicking on 'edit filters'. It's opening a filter recipe configuration, in which you can select as many filters as you want. Once selected,  click on  **SAVE**  in the top right corner, and come back to the application configuration page by clicking on the name of the dataiku application instance.

![analysis_setup.png](ZNEvkIVtIyWm)

An optional step is the empty values analysis that computes a report to show the percentage of empty values per columns. Once computed, you can click on 'open report' to see it. It'll be opened in a new tab.
Then, you can eventually type a percentage of empty values you want to automatically filter.

![empty_values_analysis.png](CF5L7pGnQR2m)