Once the target variable and its appropriate ok range or values have been selected, it is binarized into 2 classes: ok and nok. 
 **For each variable selected by the user:** 

 **Outlier filtering for numerical variables** .

 **Binning of values:**  This step divides the data for each variable into "bins" or intervals. For numerical variables, it uses the [numpy.histogram](https://numpy.org/doc/stable/reference/generated/numpy.histogram.html) function to determine the bin edges, based on the distribution of values. For categorical variables, each unique category is considered a bin.

**Default rates of variables:** For each variable, the average nok rate is calculated, which is the proportion of values that are outside the good range of the target variable.

**Default rates of bins:** For each bin, the defect rate is calculated and compared to the average nok rate of the variable.

 **Impact of variables:**  The impact is calculated as the product of the absolute difference between the bin's default rate and the variable's average default rate, and the proportion of data points in the bin. Bins with a default rate much higher or much lower than the average, and which contain a large number of data points, will therefore have a high impact.

 **Ranking of variables:**  For each variable, the absolute impact of all bins is summed. The variables are then ranked by importance, with the variable having the highest total impact first. This measure of importance is normalized to be between 0 and 100, and is used to determine the top 30 most important variables to display in the analysis.

 **Display of results:**  In each graph, the average default rate of that variable is placed, and then bubbles are positioned based on their default rate. The size of the bubbles corresponds to the number of points in the bin, and the color is red if the bin's default rate is higher than the variable's default rate, green otherwise.
 
 
